<?php
/* $Id$ */

require_once 'calendar.class.php';
require_once 'user_validate.php';
require_once 'helper.php';

valid_user();

include_once 'config.inc.php';
include_once 'eventgui.class.php';

if (! defined($_SESSION['__ROOT__']) && empty($_SESSION['__ROOT__'])) {
    session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

if (isset($_SESSION['authenticate']) && $_SESSION['authenticate']->validUser()) {
    $view_style = ($_SESSION['user_settings']->getViewStyle()) ?
        $_SESSION['user_settings']->getViewStyle() : VIEW_STYLE;
//    $timeout = ($_SESSION['user_settings']->getTimeout()) ?
//        (int) $_SESSION['user_settings']->getTimeout() : TIMEOUT;
    $week_start_sunday = ($_SESSION['user_settings']->getStartWeek() !== NULL) ?
        $_SESSION['user_settings']->getStartWeek() : WEEK_START_SUNDAY;
    $start_hour = ($_SESSION['user_settings']->getStartHour()) ?
        (int) $_SESSION['user_settings']->getStartHour() : START_HOUR;
    $end_hour = ($_SESSION['user_settings']->getEndHour()) ?
        (int) $_SESSION['user_settings']->getEndHour() : END_HOUR;
}

$pwd = WEB_ROOT;
if ($pwd[strlen($pwd)-1] == '/')
    $pwd = substr($pwd, 0, -1);

if (isset($_POST) && count($_POST) > 0) {
    $exclude = array('tzid','range','times','untildate');
    $start = array('date' => NULL, 'time' => NULL);
    $end = array('date' => NULL, 'time' => NULL);
    $referer = $_POST['referer'];
    $allDay = false;
    
    foreach ($_POST as $key => $value) {
        //echo "$key => $value<br/>";
        if (strcmp($key, 'referer') == 0)
            continue;
        if (in_array($key, $exclude))
            continue;
        if (strcasecmp($key, 'startdate') == 0) {
            $start['date'] = join('', explode('-',$value));
            continue;
        }
        if (strcasecmp($key, 'starttime') == 0) {
            $start['time'] = $value;
            if (strlen($start['time']) < 5)
                $start['time'] .= '00';
            continue;
        }
        if (strcasecmp($key, 'enddate') == 0) {
            $end['date'] = join('', explode('-',$value));
            continue;
        }
        if (strcasecmp($key, 'endtime') == 0) {
            $end['time'] = $value;
            if (strlen($end['time']) < 5)
                $end['time'] .= '00';
            continue;
        }
        if (strcasecmp("allDay", $key) == 0) {
            $allDay = true;
            continue;
        }
        if (strcasecmp("recurrence", $key) == 0) {
            $value = "FREQ=$value";
            $key = "RRULE";
        }
        //echo "$key => $value<br/>";
        $_SESSION['current_event']->setProperty($key, $value);
    }
    //echo 'DTSTART: '. $start['date'].'T'.$start['time'];
    //echo '<br/>DTEND: '. $end['date'].'T'.$end['time'];
    //exit;
    if ($allDay) {
        $_SESSION['current_event']->setProperty(
                'DTSTART;VALUE=DATE', $start['date']);
        $_SESSION['current_event']->setProperty(
                'DTEND;VALUE=DATE', $end['date']);
        //echo "<br/>".$start['date']."<br/>";
        //echo $end['date']."<br/>";
    }
    else {
        $start = strtotime($start['date'].'T'.$start['time']);
        $end = strtotime($end['date'].'T'.$end['time']);
        //echo "<br/>".Calendar::timestamp2ICal($start, FALSE)."<br/>";
        //echo Calendar::timestamp2ICal($end, FALSE)."<br/>";
        //exit;
        $_SESSION['current_event']->setProperty('DTSTART', 
                Calendar::timestamp2ICal($start, FALSE));
        $_SESSION['current_event']->setProperty('DTEND',
                Calendar::timestamp2ICal($end, FALSE));
    }
    //exit;
    if (isset($_SESSION['calendar'])) {
        $res = $_SESSION['calendar']->update(
            $_SESSION['current_event']->getUrl(),
            $_SESSION['current_event']->getEtag());
        //print_r($res);
        //exit;
        unset($_SESSION['current_event']);
        unset($_SESSION['calendar']);
        unset($_SESSION['EVENT_ACTION']);
        if (count($res) == 0) {
            header('Location: ' . $referer);
            exit;
        }
        $msg = '';
        foreach ($res as $elem) {
            $k = key($elem);
            $msg .= "$k: " . $elem[$k];
        }
    }
    else
        throw new Exception("Error updating event");
    //print "$msg\n";
    $msg = join("", explode("\n", $msg));
    $title = TITLE;
    $pwd = WEB_ROOT;
$head = <<<__HEAD
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$title</title>
<meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8"/>
<meta http-equiv="content-style-type" content="text/css"/>
<link rel="stylesheet" type="text/css" href="$pwd/css/top_level.css" />
<link rel="shortcut icon" href="$pwd/pixmaps/favicon.ico" />
<script type="text/javascript" src="$pwd/js/helper.js"></script>
</head>
<body onload="error('$msg')">
<table style="width: 100%;">
<tr>
<td style="width: 33%"><img src="$pwd/pixmaps/calendar.png" alt="calendar.png" /></td>
<td style="width: 33%; text-align: center;"><a href="$pwd/logout.php"><img style="border: 0" src="$pwd/pixmaps/exit.png" width="32" height="32" alt="Logout" /><br/>Logout</a></td>
<td style="text-align: right"><span style="font-size: 1.6em">DAViCal Web Calendar</span><br/> - A Web Interface for <a href="javascript: newwin('http://www.davical.org/');">DAViCal</a></td>
</tr>
</table>
__HEAD;
    print "$head";
    include TOP_FOLDER.'/include/menu.inc.php';
    print "<div id=\"ui\"></div>";
    include TOP_FOLDER.'/include/footer.inc.php';
    exit;
}
else {
    $query = construct_URL($_SERVER['QUERY_STRING'],
            array('etag', 'referer', 'cal'));
    //print_r($_SESSION['all_events'][$query['cal']]);
    //exit;
    if (isset($query['cal']) && ! empty($query['cal'])) {
        $_SESSION['calendar'] = $_SESSION['all_events'][$query['cal']];
        if (! is_object($_SESSION['calendar']))
            throw new Exception("Missing calendar object");
    
        if ($_SESSION['EVENT_ACTION'] == 'NEW') {
            $event = $_SESSION['calendar']->newComponent('VEVENT');
            $_SESSION['current_event'] = $event;
        }
        else {
            foreach ($_SESSION['calendar'] as $vevent) {
                if ($vevent->getEtag() == $query['etag']) {
                    $event = $vevent;
                    break;
                }
            }
            $_SESSION['current_event'] = $event;
        }
        //print $query['referer'];
        //exit;
        $gui = new EventGUI($event, $query['referer'], $query['cal']);
        //unset($_GET['referer']);
        $calendar = $gui->getView();
    }
    else {
        $text = '<h3 style="text-align: center">Choose an event from one of the listed calendars</h3>';
        $text .= '<p>';
        $text .= '<form id="cals" style="text-align: center" action="'.
                $_SERVER['PHP_SELF'].'" method="get">';
        $text .= '<input type="hidden" name="referer" value="'.urldecode($query['referer']).'" />';
        $text .= '<input type="hidden" id="cal" name="cal" value="" />';
        $calendar = '';
        foreach ($_SESSION['all_events'] as $name => $cal) {
            //$calendar .= "$name<br/>".var_export($cal, true)."<br/>";
	        $text .= $name.': <select name="etag"
                    onchange="setCalendar(\'cals\', \'cal\', '."'$name'".')">';
            $text .= '<option selected="selected"></option>';
            foreach ($cal as $vevent) {
                $calendar .= $vevent->getEtag()."<br/>";
                $text .= '<option value="'.$vevent->getEtag().'">'.
                    $vevent->getDetails().'</option>';
            } 
            $text .= '</select><br/><br/>';
        }
        $text .= '<input type="submit" value="Continue" />';
        $text .= '</form></p>';
        //print "{$_GET['referer']}";
        //exit;
	    print popup_window($text, $query['referer']);
        exit;
    }
}
include TOP_FOLDER.'/include/header.inc.php';
include TOP_FOLDER.'/include/menu.inc.php';

print "<div id=\"ui\">$calendar</div>";
include TOP_FOLDER.'/include/footer.inc.php';
?>
