<?php
/* $Id$ */
if (! file_exists('config.inc.php') || filesize('config.inc.php') == 0) {
    header("Location: install/install.php");
    exit();
}

/* remove pgsql.php from root. Accidentally placed there in release 0.7.4 */
$cwd = dirname(__FILE__);
if (file_exists("$cwd/pgsql.php")) {
    if (! unlink("$cwd/pgsql.php")) {
        echo "An unrecoverable error has occured call the administrator an inform
            him that he should read the error log file for further assistans";
        error_log("$cwd/pgsql.php: Must be deleted.\nI tried but it failed due to
                missing permissions. You must delete it manually");
        exit;
    }
}

$timezone_offset = date("Z");

include_once 'config.inc.php';
require_once 'user_validate.php';
require_once 'utils/helper.php';

$_SESSION['timezone_offset'] = $timezone_offset;

$_SESSION['__ROOT__'] = TOP_FOLDER;

if (PHP_VERSION < 5.1) {
    die("PHP >= 5.1 is required to run this application");
}

valid_user();

if (strtoupper($_SESSION['user_settings']->getUid()) == 'ADMIN' && newUpdates()) {
    $pwd = WEB_ROOT;
    if ($pwd[strlen($pwd)-1] == '/')
        $pwd = substr($pwd, 0, -1);
    
    print '<?xml version="1.0" encoding="utf-8"?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
        <head>
            <title>Web Calendar</title>
            <link rel="stylesheet" type="text/css"
                href="'.$pwd.'/css/top_level.css" />
            <link rel="shortcut icon"
                href="'.$pwd.'/pixmaps/favicon.ico" />
            <script type="text/javascript" src="'.$pwd.'/js/helper.js"></script>
        </head>
        <body>
            <div id="update_msg">
                <h3 style="text-align: center">
                New updates available for the database
                </h3>
                <div style="text-align: center">
                <button type="button" name="cancel" 
                    onclick="javascript:redirect('."'navigate/goto_today.php'".')">Skip</button>
                <button type="button" value="upgrade"
                    onclick="javascript:redirect('."'utils/upgrade_db.php'".')">Upgrade</button>
                </div>
            </div>
        </body>
    </html>';
}
else
    include 'navigate/goto_today.php';
?>
