<?php
/* $Id$ */
require_once 'config.inc.php';
require_once 'user_validate.php';
require_once 'timezone.php';
require_once 'helper.php';

valid_user();

if (! defined($_SESSION['__ROOT__']) && empty($_SESSION['__ROOT__'])) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

require_once 'persistens.php';

$user = $_SESSION['user_settings'];

if (count($_POST) > 0 && isset($_POST['action'])) {
    $db = Persistens::getInstance(DBDRIVER);

    if ($_POST['action'] == "password") {
        if ($_POST['pwd1'] == $_POST['pwd2']) {
            $res = $db->changePassword($user->getUid(), sha1($_POST['pwd1']));
            if ($res === TRUE) {
                header("Location: " . WEB_ROOT . "logout.php");
                exit();
            }
            //else {
            //    $res = "uid: ".$user->getUid()." ".$_POST['pwd1']." ".$_POST['pwd2']." -> $res";
            //}
        }
        else {
            $res = "Passwords did not compare";
        }
        $pageView =  "<p style=\"text-align: center\">$res</p>";
    }
    else if ($_POST['action'] == "settings") {
        file_put_contents('/tmp/davical.log',
            __FILE__ . ": " . var_export($_POST, TRUE), FILE_APPEND);
        $conf = array();
        if ($_POST['endDay'] > $_POST['startDay']) {
            $conf['daystart'] = $_POST['startDay'];
            $conf['dayend'] = $_POST['endDay'];
        }
        else {
            $conf['daystart'] = $user->getStartHour();
            $conf['dayend'] = $user->getEndHour();
        }
        $conf['timeout'] =
            ($_POST['timeout'] > 0) ? $_POST['timeout'] * 60 :
                $user->getTimeout() / 60;
        $conf['userview'] = $_POST['viewStyle'];
        $conf['weekstart'] = ($_POST['startWeek'] == 'SU') ? 1 : 0;
        $conf['timezone'] = $_POST['timezone'];
        $conf['userrole'] = $user->getRole();
        $res = $db->setUserSettings($user->getUid(), $conf);
        if ($res === TRUE) {
            $user->setSettings(array($conf));
            header("Location: " . $_SERVER['PHP_SELF']);
            exit();
        }
        $pageView =  "<p style=\"text-align: center\">$res</p>";
    }
}
else {
    $timeout = $user->getTimeout() / 60;
    $viewStyle = $user->getViewStyle();
    switch ($viewStyle) {
        case 'day':
            $viewStyle = <<<_SELECT
                <select name="viewStyle">
                    <option value="day" selected="true">Day</option>
                    <option value="week">Week</option>
                    <option value="month">Month</option>
                </select>
_SELECT;
            break;
        case 'week':
            $viewStyle = <<<_SELECT
                <select name="viewStyle">
                    <option value="day">Day</option>
                    <option value="week" selected="true">Week</option>
                    <option value="month">Month</option>
                </select>
_SELECT;
            break;
        case 'month':
            $viewStyle = <<<_SELECT
                <select name="viewStyle">
                    <option value="day">Day</option>
                    <option value="week">Week</option>
                    <option value="month" selected="true">Month</option>
                </select>
_SELECT;
            break;
    }
    $weekStart = $user->getStartWeek();
    if ($weekStart)
        $weekStart = <<<_SELECT
            <select name="startWeek">
                <option value="SU" selected="true">Sunday</option>
                <option value="MO">Monday</option>
            </select>
_SELECT;
    else
        $weekStart = <<<_SELECT
            <select name="startWeek">
                <option value="SU">Sunday</option>
                <option value="MO" selected="true">Monday</option>
            </select>
_SELECT;

    $dayStart = (int) $user->getStartHour();
    $start = '<select name="startDay">';
    for ($i = 0; $i < 25; $i++) {
        $hour = ($i < 10) ? "0$i:00" : "$i:00";
        $start .= "<option value=\"$i\"";
        if ($i == $dayStart)
            $start .= " selected=\"true\"";
        $start .= ">$hour</option>";
    }
    $start .= '</select>';
    $dayEnd = (int) $user->getEndHour();
    $end = '<select name="endDay">';
    for ($i = 0; $i < 25; $i++) {
        $hour = ($i < 10) ? "0$i:00" : "$i:00";
        $end .= "<option value=\"$i\"";
        if ($i == $dayEnd)
            $end .= " selected=\"true\"";
        $end .= ">$hour</option>";
    }
    $end .= '</select>';

    $current = $user->getTimezone();
    foreach ($timezones as $timezone) {
        $tz .= "<option value=\"$timezone\"";
        if ($current == $timezone)
            $tz .= ' selected="true"';
        $tz .= ">$timezone</option>";
    }

    $url = getServerUrl();
    if ($url[strlen($url)-1] == '/')
        $url = substr($url, 0, -1);

    $pageView = <<< __EOF
    <p>
        <form action="{$_SERVER['PHP_SELF']}" method="post">
            <table class="config">
                <tr>
                    <th>Setting</th><th>Current</th>
                </tr>
                <tr>
                    <td class="config">Session timeout in minuts</td>
                    <td class="config">
                        <input size="6" name="timeout" type="text" value="$timeout"/>
                    </td>
                </tr>
                <tr>
                    <td class="config">Default view</td><td>$viewStyle</td>
                </tr>
                <tr>
                    <td class="config">Timezone</td>
                    <td class="config">
                        <select name="timezone">
                            $tz
                        </select>
                    </td>
                </tr>
                <tr>
                    <td class="config">Week start on</td><td>$weekStart</td>
                </tr>
                <tr>
                    <td class="config">Day start</td>
                    <td class="config">$start</td>
                </tr>
                <tr>
                    <td class="config">Day end</td>
                    <td class="config">$end</td>
                </tr>
                <tr>
                    <input type="hidden" name="action" value="settings"/>
                    <td class="config" colspan="2" style="text-align: center">
                        <input type="submit" name="setting" value="Submit changes"/>
                    </td>
                </tr>
            </table>
        </form>
    </p>
__EOF;
    if (strtoupper($user->getUid()) != 'ADMIN') {
    $pageView .= <<< __EOF
    <p style="text-align: center">
        <button type="button" id="calconfig"
                onclick="document.location.href='$url/utils/calendar.php'">
            Configure Calendars
        </button>
    </p>
__EOF;
    }
    if ($user->getRole() === 0) {
    $pageView .= <<<__EOF
    <p style="text-align: center">
        <button type="button" id="useradm"
                onclick="document.location.href='$url/utils/users.php'">
            Manage users
        </button>
        &nbsp;&nbsp;
        <button type="button" id="ldapadm"
                onclick="document.location.href='$url/utils/ldap.php'">
            Configure LDAP
        </button>
    </p>
__EOF;
    }
    $pageView .= <<<__EOF
    <p>
        <form action="{$_SERVER['PHP_SELF']}" method="post">
            <table class="config">
                <tr>
                    <th colspan="2" style="text-align: center">Change password</th>
                </tr>
                <tr>
                    <td colspan="2"><span style="background: red; font-weight: bold;">
                        &nbsp;After changing the password a relogin is required&nbsp;
                    </span></td>
                </tr>
                <tr>
                    <td class="config">New Password</td>
                    <td class="config"><input name="pwd1" type="password"/></td>
                </tr>
                <tr>
                    <td class="config">Repeat Password</td>
                    <td class="config"><input name="pwd2" type="password"/></td>
                </tr>
                <tr>
                    <input type="hidden" name="action" value="password"/>
                    <td class="config" colspan="2" style="text-align: center">
                        <input type="submit" name="password" value="Submit"/>
                    </td>
                </tr>
            </table>
        </form>
    </p>
__EOF;
}

include TOP_FOLDER.'/include/header.inc.php';
include TOP_FOLDER.'/include/menu.inc.php';

print "<div id=\"ui\">$pageView</div>";

include TOP_FOLDER.'/include/footer.inc.php';
?>
