<?php
/* $Id$ */
require_once 'config.inc.php';
require_once 'user_validate.php';
require_once 'helper.php';

valid_user();

if (! defined($_SESSION['__ROOT__']) && empty($_SESSION['__ROOT__'])) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

require_once 'persistens.php';

$user = $_SESSION['user_settings'];

if ($user->getRole() !== 0) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

$db = Persistens::getInstance(DBDRIVER);

if (count($_POST) > 0) {
	$config = array(
		(isset($_POST['enable']) && $_POST['enable'] == 'on') ? 1 : 0,
		$_POST['dns'],
		(isset($_POST['tls']) && $_POST['tls'] == 'on') ? 1 : 0,
		$_POST['base_dn'],
		$_POST['user_attr']
	);
	if (($res = $db->setLdapConfig($config)) === true)		
		$pageView = "<p style=\"text-align: center\">
			LDAP configuration was successfully updated</p>";
	else
		$pageView = "<p style=\"text-align: center\">$res</p>";
}
else {
	$config = $db->getLdapConfig();
	if (! is_array($config) && $config) {
		if (session_id())
			session_destroy();
		header('Location: ' . WEB_ROOT . 'error.html');
		exit;
	}

	$enable = ($config['enable']) ? ' checked="checked"' : '';
	$tls = ($config['tls']) ? ' checked="checked"' : '';
	$dns = $config['dns'];
	$base_dn = $config['base_dn'];
	$user_attr = $config['user_attr'];
    $pageView = <<< __EOF
        <form action="{$_SERVER['PHP_SELF']}" method="post">
            <table class="config">
                <tr>
                    <th>Setting</th><th>Current</th>
                </tr>
                <tr>
                    <td class="config">LDAP enabled</td>
                    <td class="config">
                        <input name="enable" type="checkbox"$enable/>
                    </td>
                </tr>
                <tr>
                    <td class="config">URL</td>
                    <td class="config">
                        <input size="30" name="dns" type="text" value="$dns"/>
                    </td>
                </tr>
                <tr>
                    <td class="config">Use TLS</td>
                    <td class="config">
                        <input name="tls" type="checkbox"$tls/>
                    </td>
                </tr>
                <tr>
                    <td class="config">Base DN</td>
                    <td class="config">
                        <input size="30" name="base_dn" type="text" value="$base_dn"/>
                    </td>
                </tr>
                <tr>
                    <td class="config">User ATTR</td>
                    <td class="config">
                        <input name="user_attr" type="text" value="$user_attr"/>
                    </td>
                </tr>
                <tr>
                    <td class="config" colspan="2" style="text-align: center">
                        <input type="submit" name="setting" value="Submit changes"/>
                    </td>
                </tr>
            </table>
        </form>
	<p>
		After enabling LDAP users will be authenticated by LDAP and when
		a user logs on for the first time an account will automatically
		be created using the username provided by LDAP. If the user
		account is removed from LDAP the account will be deactivated but
		remain in webcal until deleted by the admin user.<br/>
		<br/>
		If your LDAP server is located here: <span class="bold">ldap.foo.tld
		</span> on either port
		389 or 636 then URL is:<br/>
		Without SSL (389): <span class="bold">ldap://</span>ldap.foo.tld<br/>
		With SSL (636): <span class="bold">ldaps://</span>ldap.foo.tld<br/>
		With TLS (389): <span class="bold">ldap://</span>ldap.foo.tld and 
		<span class="bold">check "Use TLS"</span><br/>
		If your LDAP server is listen on 8389 then this port number must
		be added to the URL like ldap://ldap.foo.tld<span class="bold">:8389</span><br/>
		<br/>
		If your Bind DN is the following: uid=username,ou=people,dc=foo,
		dc=tld then "Base DN" and "User ATTR" has to look like this:<br/>
		Base DN: <span class="bold">ou=people,dc=foo,dc=tld</span><br/>
		User ATTR: <span class="bold">uid</span><br/>
		If your Bind DN is the following: cn=username,dc=foo,dc=tld then
		"Base DN" and "User ATTR" has to look like this:<br/>
		Base DN: <span class="bold">dc=foo,dc=tld</span><br/>
		User ATTR: <span class="bold">cn</span>
    </p>
__EOF;
}

include TOP_FOLDER.'/include/header.inc.php';
include TOP_FOLDER.'/include/menu.inc.php';

print "<div id=\"ui\">$pageView</div>";

include TOP_FOLDER.'/include/footer.inc.php';
?>