<?php
/* $Id$ */
require_once 'config.inc.php';
require_once 'user_validate.php';
require_once 'helper.php';

valid_user();

if (! defined($_SESSION['__ROOT__']) && empty($_SESSION['__ROOT__'])) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

if (! has_admin_role()) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

require_once 'persistens.php';

include TOP_FOLDER.'/include/header.inc.php';
include TOP_FOLDER.'/include/menu.inc.php';
$self =$_SERVER['PHP_SELF'];
$db = Persistens::getInstance(DBDRIVER);

if (count($_POST) > 0 && isset($_POST['action'])) {

    if (strtolower($_POST['action']) == 'add') {
        if ($_POST['pwd1'] != $_POST['pwd2']) {
            $result = "Password does not match";
        }
        else {
            $data = create_user_data(
                    $_POST['uid'], $_POST['pwd1'], $_POST['role']);
            $result = $db->newUser($data);
            if ($result === TRUE) {
                $name = $db->getRoleName((int) $_POST['role']);
                $result = "{$_POST['uid']} with role: {$name['name']} added";
            }
            $result = nl2br($result);
        }
    }
    $pageView .= <<<__EOF
<p style="text-align: center">
    $result
</p>
__EOF;
}
else {
    $roles = $db->getRoles();
    $select = '<select name="role">';
    foreach ($roles as $role) {
        $select .= "<option value=\"{$role['id']}\">{$role['name']}</option>";
    }
    $select .= "</select>";
    $pageView .= <<<__EOF
    <form action="$self" method="post" id="new_form">
    <p>
        <table class="config">
            <tr>
                <th colspan="2" style="text-align: center">New user</th>
            </tr>
            <tr>
                <td class="config">Username</td>
                <td class="config"><input name="uid" type="text"/></td>
            </tr>
            <tr>
                <td class="config">User role</td>
                <td class="config">$select</td>
            </tr>
            <tr>
                <td class="config">Password</td>
                <td class="config"><input name="pwd1" type="password"/></td>
            </tr>
            <tr>
                <td class="config">Repeat Password</td>
                <td class="config"><input name="pwd2" type="password"/></td>
            </tr>
            <tr>
                <td class="config" colspan="2" style="text-align: center">
                    <input type="submit" name="action" value="Add"/>
                </td>
            </tr>
        </table>
    </p>
    </form>
__EOF;
}

print "<div id=\"ui\">$pageView</div>";

include TOP_FOLDER.'/include/footer.inc.php';

?>
